import React, { RefObject } from 'react';

export type ModalProps<T = Object> = T & {
  close: (...args: any[]) => void;
  modalRef: RefObject<HTMLDivElement>;
};

export type ModalType<T> = React.ElementType<any & ModalProps<T>>;

export interface ModalEventDetail<K = Object> {
  component: ModalType<K>;
  props: K;
  resolve: (...args: any[]) => void;
  target?: HTMLElement;
}

export interface ModalSetter<K = Object> extends ModalEventDetail<K> {
  close: (...args: any[]) => void;
}
