import { Picture } from './picture.interface';

export enum OAuth2ClientURLType {
  REDIRECT_URI = 'redirect_uri',
  TERMS = 'terms',
  PRIVACY = 'privacy',
  WEBSITE = 'website',
}

export interface OAuth2ClientURL {
  id: number;
  url: string;
  type: OAuth2ClientURLType;
  created_at: Date;
  updated_at: Date;
}

export interface OAuth2ClientListItem {
  id: number;
  client_id: string;
  client_secret: string;
  title: string;
  description: string;
  scope: string;
  grants: string;
  activated: boolean;
  verified: boolean;
  created_at: string;
  updated_at: string;
  urls?: OAuth2ClientURL[];
  picture?: Picture;
  owner?: {
    id: number;
    uuid: string;
    username: string;
  };
}
